@echo off
cls
echo.
echo.
echo  RTMM Season Map Injector Uiltity v0.91   7-15-2019
echo  Copyright 2019 by Return to Misty Moorings. All Rights Reserved.  
echo.
echo.
echo  This utility will check your scenery folders and
echo  compare folder names to the Season Map XMLs contained
echo  in the supplied Season Map XMLs folder. When there is 
echo  a match, the utility will copy the matching
echo  Season Map XML to the appropriate seasonal scenery folder.
echo.
echo  Note: Only the scenery folders that contain seasonal 
echo        files will be updated. This utility does not delete
echo        any of your files. 
echo.
echo.
pause

rem Check if FSX or P3D running

tasklist /FI "IMAGENAME eq prepar3d.exe" 2>NUL | find /I /N "prepar3d">NUL
if "%ERRORLEVEL%" == "0" goto p3d 
tasklist /FI "IMAGENAME eq fsx.exe" 2>NUL | find /I /N "fsx">NUL
if "%ERRORLEVEL%" == "0" goto FSX  
goto continue
:P3D
cls
echo.
echo   prepar3d.exe is running! Please exit Prepar3D 
echo   and then restart the RTMMSeasonMapInjector utility.
echo.
pause
goto :end
:FSX
cls
echo.
echo   fsx.exe is running! Please exit FSX 
echo   and then restart the RTMMSeasonMapInjector utility.
:end 
exit
:continue

rem Set current directory to location of Batch script, Get Season Maps XML <date> directory name with and without the version date, verify that a Season Maps XMLs directory is present

pushd "%~dp0"
FOR /F "TOKENS=*" %%F IN ('DIR /B /AD "season_map_xmls*" 2^>nul') DO SET SeasonMapDirName=%%~F 
IF NOT DEFINED SeasonMapDirName goto noseasonmapxmlsfolder 
set SeasonMapDirNameShort=%SeasonMapDirName:~0,15%
goto continue2
:noseasonmapxmlsfolder
set specialecho="The Season_Map_XMLs_<date> folder is not present!"
echo.
echo.
echo  %specialecho%
echo.	
echo.
pause
exit
:continue2
set folder=No folder selected!
cls
echo.
echo  RTMM Season Map Injector Uiltity v0.91   7-15-2019
echo  Copyright 2019 by Return to Misty Moorings. All Rights Reserved.  
echo.
echo.
echo  This utility will now ask you to identify the folder
echo  that contains your installed RTMM scenery folders using a 
echo  browser window.  Many users keep these folders in a folder 
echo  named RTMM Scenery Library. Please use the browser to choose  
echo  the folder that contains your RTMM Scenery Folders and
echo  and then click on the "OK" button.
echo.  
pause
set "psCommand="(new-object -COM 'Shell.Application')^
.BrowseForFolder(0,'Please choose a folder.',0,0).self.path""
for /f "usebackq delims=" %%I in (`powershell %psCommand%`) do set "folder=%%I"
cls
echo.
echo.
echo  Folder Chosen was:
echo.
echo  %folder%   
echo.
echo Is this the correct folder?
echo.
set /p choice=Please type 1 for "yes" or any other letter, number or spacebar for "no" and hit enter...
echo. 
echo.
echo.
if "%choice%" NEQ "1" goto continue2
color 47
cls
echo.
echo.
echo.
echo  ... RTMM Season Map Injector Utility is checking and updating ...
echo.
timeout /t 4 >nul   

rem set environment, reset variables and load UserSceneryDirectoryList.txt

set local >nul 2>&1
del /q seasonmapsfilelist.txt >nul 2>&1
del /q RTMMSeasonMapInjectorLog.txt >nul 2>&1
del /q userscenerydirectorylist.txt >nul 2>&1
del /q userscenerydirectory.txt >nul 2>&1      rem this is list used for processing
del /q SceneryFolderProblemList.txt >nul 2>&1
set counter=0
set foldercount=0
set skipcounter=0
dir "%folder%" /AD/B >>UserSceneryDirectory.txt

Rem Initialzie outputfiles

echo RTMM Season Map Injector Utility was run on %date% %time% >> RTMMSeasonMapInjectorLog.txt
echo. >> RTMMSeasonMapInjectorLog.txt
echo The following Season Map XML files were written or updated: >> RTMMSeasonMapInjectorLog.txt
echo. >> RTMMSeasonMapInjectorLog.txt

echo RTMM Season Map Injector Utility was run on %date% %time% >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo The following Scenery Folders (if any) were flagged for update but skipped for one of the reasons shown below: >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo  1. If message shows '...Season Map XML file not copied', then it is probably one of the two following problems: >> SceneryFolderProblemList.txt 
echo. >> SceneryFolderProblemList.txt
echo     a) No seasonal files were found in the folder checked but the scenery has probably been enhanced >> SceneryFolderProblemList.txt 
echo        with seasonal files in RTMM's Scenery Library or >> SceneryFolderProblemList.txt
echo     b) The folder structure for the folder checked is not standard. >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo  2. If message shows '...Seasonal scenery but no Season Map XML matched', then the folder name has probably >> SceneryFolderProblemList.txt
echo     been changed in the RTMM Scenery Library. >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo  Scenery folder problem list: >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo RTMM Season Map Injector Utility was run on %date% %time% >> UserSceneryDirectoryList.txt
echo. >> UserSceneryDirectoryList.txt
echo The following "parent" folder was selected by the user to be checked: >> UserSceneryDirectoryList.txt
echo. >> UserSceneryDirectoryList.txt
echo %folder% >> UserSceneryDirectoryList.txt
echo. >> UserSceneryDirectoryList.txt

rem Prepare for processing by removing trailing spaces from SeasonMapDirName and then create a SeasonMapsFileList.txt file of the directory's contents.

set "SeasonMapDirName=%SeasonMapDirName: =%"
dir "%SeasonMapDirName%" /B >SeasonMapsFileList.txt 

rem Begin processing....

SetLocal ENABLEDELAYEDEXPANSION

for /f "tokens=* delims=" %%a in ('type UserSceneryDirectory.txt ') DO (
        set /a foldercount=!foldercount!+1   
        set "WriteXML=NoMatch" 
        for /f "tokens=* delims=" %%b in ('type SeasonMapsFileList.txt ') DO (
               set SeasonMapFileName=%%b
               set SeasonMapFileName=!SeasonMapFileName:~0,-14%!
               if !SeasonMapFileName!==%%a (
                   If not exist !folder!\%%a\scenery\*_rtmm_*.* echo !folder!\%%a ...Season Map XML file not copied >> "SceneryFolderProblemList.txt"
		   If not exist !folder!\%%a\scenery\*_rtmm_*.* echo. >> "SceneryFolderProblemList.txt"
                   set "WriteXML=True"
                   If not exist !folder!\%%a\scenery\*_rtmm_*.* set "WriteXML=False"
 		   If not exist !folder!\%%a\scenery\*_rtmm_*.* set /a skipcounter =!skipcounter!+1 	
               )  
               if !WriteXML!==True (
                   if !SeasonMapFileName!==%%a (
                   xcopy "!SeasonMapDirName!\%%b" "!folder!\%%a\scenery\" /q /r /y >nul 2>&1
		   if exist !folder!\%%a\scenery\%%b set /a counter=!counter!+1 
                   if exist !folder!\%%a\scenery\%%b echo !folder!\%%a\%%b >> RTMMSeasonMapInjectorLog.txt
                   if exist !folder!\%%a\scenery\%%b echo. >> RTMMSeasonMapInjectorLog.txt
                   )
               )  
         )
         if !WriteXML!==NoMatch (          
               set "SeasonFound=No"
               If exist !folder!\%%a\scenery\*_rtmm_winter.* set "SeasonFound=Yes"
               If exist !folder!\%%a\scenery\*_rtmm_spring.* set "SeasonFound=Yes"
               If exist !folder!\%%a\scenery\*_rtmm_summer.* set "SeasonFound=Yes"
               If exist !folder!\%%a\scenery\*_rtmm_fall.* set "SeasonFound=Yes"
               If exist !folder!\%%a\scenery\*_rtmm_noseason.* set "SeasonFound=Yes"
               If !SeasonFound!==Yes ( 
                  echo !folder!\%%a ...Seasonal scenery but No Season Map XML matched! >> "SceneryFolderProblemList.txt"
	          echo. >> "SceneryFolderProblemList.txt"
                  set /a skipcounter =!skipcounter!+1
               )    
         )           
)

SetLocal DISABLEDELAYEDEXPANSION

rem  Complete the population of the RTMMSeasonMapInjectorLog.txt, SceneryFolderProblemList.txt & UserSceneryDirectoryList.txt output files

echo. >> RTMMSeasonMapInjectorLog.txt
echo. >> RTMMSeasonMapInjectorLog.txt
echo                    RTMM Season Map Injector Utility Summary Totals >> RTMMSeasonMapInjectorLog.txt
echo. >> RTMMSeasonMapInjectorLog.txt
echo %counter% Scenery folders were revised with a new or updated Season Map File! See detail above. >> RTMMSeasonMapInjectorLog.txt
echo %skipcounter% Scenery folders were flagged for problems, see SceneryFolderProblemList.txt file for detail! >> RTMMSeasonMapInjectorLog.txt
set /A "notseasonal=%foldercount% - %counter% - %skipcounter%" 
echo %notseasonal% Scenery folders were found to be non-seasonal and no updates or problems were logged! >> RTMMSeasonMapInjectorLog.txt
echo. >> RTMMSeasonMapInjectorLog.txt
echo %foldercount% Scenery folders were checked! Please see UserSceneryDirectoryList.txt file for a folder list! >> RTMMSeasonMapInjectorLog.txt

echo. >> SceneryFolderProblemList.txt
echo. >> SceneryFolderProblemList.txt
echo %skipcounter% Scenery folders were flagged as problems.  If all user's seasonal scenery folders are RTMM eSwitcher ready then this utility should not report any scenery problems.    >> SceneryFolderProblemList.txt
 
echo %foldercount% scenery folder names were checked using the selected "parent" folder shown above. They are listed below: >> UserSceneryDirectoryList.txt
echo. >> UserSceneryDirectoryList.txt
dir "%folder%" /AD/B >>UserSceneryDirectoryList.txt

rem  Clean up and do console output!

del /q SeasonMapsFileList.txt >nul 2>&1
del /q userscenerydirectory.txt >nul 2>&1      rem this is list used for processing
color 07
cls
echo  RTMM Season Map Injector Uiltity v0.91   7-15-2019
echo  Copyright 2019 by Return to Misty Moorings. All Rights Reserved.  
echo.
echo        ... Injection Complete! ...
echo.
echo  %foldercount% scenery folders were checked! The UserSceneryDirectoryList.txt
echo  file contains a list of the folders checked.
echo.
echo  %skipcounter% scenery folders were flagged as problems and no Season Map XML  
echo  files were copied since folder either matched a Season Map XML but was not   
echo  seasonal or folder structure was not standard or folder was seasonal but
echo  no matching Season Map XML was found. The SceneryFolderProblemList.txt file 
echo  contains a list of the problem folders along with more information. 
echo.
echo  %counter% Season Map XML files were copied! The RTMMSeasonMapInjectorLog.txt
echo  file contains a list of which scenery folders were updated.
echo. 
echo  Note:  The 3 output files, that are referenced above, were written to the 
echo  RTMM Season Map Injector utility folder that contains this utility that you 
echo  just ran.  If you want to inspect the files that were output, make sure you
echo  do that right after you exit this utility or save the the output files to
echo  a different folder before running the injector utility again. The RTMM 
echo  Season Map Injector Utility deletes the old output files upon startup!
echo.
pause
exit
  


